chiark / gitweb /
README: ppa only works for Ubuntu based systems
[fdroidserver.git] / tests / run-tests
1 #!/bin/bash
2
3 set -e # quit script on error
4 set -x # show each command as it is executed
5
6 echo_header() {
7     echo "=============================================================================="
8     echo $1
9 }
10
11 copy_apks_into_repo() {
12     set +x
13     for f in `find $APKDIR -name '*.apk' | grep -F -v -e unaligned -e unsigned -e badsig -e badcert`; do
14         name=$(basename $(dirname `dirname $f`))
15         apk=`$aapt dump badging "$f" | sed -n "s,^package: name='\(.*\)' versionCode='\([0-9][0-9]*\)' .*,\1_\2.apk,p"`
16         test $f -nt repo/$apk && rm -f repo/$apk  # delete existing if $f is newer
17         if [ ! -e repo/$apk ] && [ ! -e archive/$apk ]; then
18             echo "$f --> repo/$apk"
19             ln $f $1/repo/$apk || \
20                 rsync -axv $f $1/repo/$apk # rsync if hard link is not possible
21         fi
22     done
23     set -x
24 }
25
26 # keep this as an old version to test the automatic parsing of build-tools
27 # verion numbers in `fdroid init`
28 create_fake_android_home() {
29     mkdir $1/tools
30     mkdir $1/platform-tools
31     mkdir $1/build-tools
32     mkdir $1/build-tools/19.0.2
33     touch $1/build-tools/19.0.2/aapt
34 }
35
36 create_test_dir() {
37     test -e $WORKSPACE/.testfiles || mkdir $WORKSPACE/.testfiles
38     mktemp --directory --tmpdir=$WORKSPACE/.testfiles
39 }
40
41 create_test_file() {
42     test -e $WORKSPACE/.testfiles || mkdir $WORKSPACE/.testfiles
43     mktemp --tmpdir=$WORKSPACE/.testfiles
44 }
45
46 #------------------------------------------------------------------------------#
47 # "main"
48
49 if [ "$1" = "-h" ] || [ "$1" = "--help" ]; then
50     set +x
51     echo "Usage: $0 '/path/to/folder/with/apks'"
52     exit 1
53 fi
54
55 if [ -z "$ANDROID_HOME" ]; then
56     echo "ANDROID_HOME must be set with the path to the Android SDK, i.e.: "
57     echo "  export ANDROID_HOME=/opt/android-sdk"
58     exit 1
59 fi
60
61 if [ -z "$1" ]; then
62     APKDIR=`pwd`
63 else
64     APKDIR=$1
65 fi
66
67 if [ -z $WORKSPACE ]; then
68     WORKSPACE=`dirname $(pwd)`
69     echo "Setting Workspace to $WORKSPACE"
70 fi
71
72 # allow the location of the script to be overridden
73 if [ -z $fdroid ]; then
74     fdroid="$WORKSPACE/fdroid"
75 fi
76
77 # allow the location of aapt to be overridden
78 if [ -z $aapt ]; then
79     aapt=`ls -1 $ANDROID_HOME/build-tools/*/aapt | sort | tail -1`
80 fi
81
82 # allow the location of python to be overridden
83 if [ -z $python ]; then
84     python=python2
85 fi
86
87
88 #------------------------------------------------------------------------------#
89 echo_header "run commit hooks"
90
91 cd $WORKSPACE
92 ./hooks/pre-commit
93
94
95 #------------------------------------------------------------------------------#
96 echo_header "test python getsig replacement"
97
98 cd $WORKSPACE/tests/getsig
99 ./make.sh
100 for testcase in $WORKSPACE/tests/*.TestCase; do
101     $testcase
102 done
103
104
105 #------------------------------------------------------------------------------#
106 echo_header "create a source tarball and use that to build a repo"
107
108 cd $WORKSPACE
109 $python setup.py sdist
110
111 REPOROOT=`create_test_dir`
112 cd $REPOROOT
113 tar xzf `ls -1 $WORKSPACE/dist/fdroidserver-*.tar.gz | sort -n | tail -1`
114 cd $REPOROOT
115 ./fdroidserver-*/fdroid init
116 copy_apks_into_repo $REPOROOT
117 ./fdroidserver-*/fdroid update --create-metadata
118
119
120 #------------------------------------------------------------------------------#
121 echo_header "test config checks of local_copy_dir"
122
123 REPOROOT=`create_test_dir`
124 cd $REPOROOT
125 $fdroid init
126 $fdroid update --create-metadata
127 $fdroid server update --local-copy-dir=/tmp/fdroid
128
129 # now test the errors work
130 set +e
131 $fdroid server update --local-copy-dir=thisisnotanabsolutepath
132 if [ $? -eq 0 ]; then
133     echo "This should have failed because thisisnotanabsolutepath is not an absolute path!"
134     exit 1
135 else
136     echo "testing absolute path checker passed"
137 fi
138 $fdroid server update --local-copy-dir=/tmp/IReallyDoubtThisPathExistsasdfasdf
139 if [ $? -eq 0 ]; then
140     echo "This should have failed because the path does not end with 'fdroid'!"
141     exit 1
142 else
143     echo "testing dirname exists checker passed"
144 fi
145 $fdroid server update --local-copy-dir=/tmp/IReallyDoubtThisPathExistsasdfasdf/fdroid
146 if [ $? -eq 0 ]; then
147     echo "This should have failed because the dirname path does not exist!"
148     exit 1
149 else
150     echo "testing dirname exists checker passed"
151 fi
152 set -e
153
154
155 #------------------------------------------------------------------------------#
156 echo_header "setup a new repo from scratch using ANDROID_HOME and do a local sync"
157
158 REPOROOT=`create_test_dir`
159 cd $REPOROOT
160 $fdroid init
161 copy_apks_into_repo $REPOROOT
162 $fdroid update --create-metadata
163 grep -F '<application id=' repo/index.xml > /dev/null
164
165 LOCALCOPYDIR=`create_test_dir`/fdroid
166 $fdroid server update --local-copy-dir=$LOCALCOPYDIR
167 NEWREPOROOT=`create_test_dir`
168 cd $NEWREPOROOT
169 $fdroid init
170 $fdroid server update --local-copy-dir=$LOCALCOPYDIR --sync-from-local-copy-dir
171
172
173 #------------------------------------------------------------------------------#
174 # check that --android-home fails when dir does not exist or is not a dir
175
176 REPOROOT=`create_test_dir`
177 KEYSTORE=$REPOROOT/keystore.jks
178 cd $REPOROOT
179 set +e
180 $fdroid init --keystore $KEYSTORE --android-home /opt/fakeandroidhome
181 if [ $? -eq 0 ]; then
182     echo "This should have failed because /opt/fakeandroidhome does not exist!"
183     exit 1
184 else
185     echo "testing android-home path checker passed"
186 fi
187 TESTFILE=`create_test_file`
188 $fdroid init --keystore $KEYSTORE --android-home $TESTFILE
189 if [ $? -eq 0 ]; then
190     echo "This should have failed because $TESTFILE is a file not a dir!"
191     exit 1
192 else
193     echo "testing android-home not-dir checker passed"
194 fi
195 set -e
196
197
198 #------------------------------------------------------------------------------#
199 echo_header "check that fake android home passes 'fdroid init'"
200
201 REPOROOT=`create_test_dir`
202 FAKE_ANDROID_HOME=`create_test_dir`
203 create_fake_android_home $FAKE_ANDROID_HOME
204 KEYSTORE=$REPOROOT/keystore.jks
205 cd $REPOROOT
206 $fdroid init --keystore $KEYSTORE --android-home $FAKE_ANDROID_HOME
207
208
209 #------------------------------------------------------------------------------#
210 echo_header "check that 'fdroid init' fails when build-tools cannot be found"
211
212 if [ -e /usr/bin/aapt ]; then
213     echo "/usr/bin/aapt exists, not running test"
214 else
215     REPOROOT=`create_test_dir`
216     FAKE_ANDROID_HOME=`create_test_dir`
217     create_fake_android_home $FAKE_ANDROID_HOME
218     rm -f $FAKE_ANDROID_HOME/build-tools/*/aapt
219     KEYSTORE=$REPOROOT/keystore.jks
220     cd $REPOROOT
221     set +e
222     $fdroid init --keystore $KEYSTORE --android-home $FAKE_ANDROID_HOME
223     [ $? -eq 0 ] && exit 1
224     set -e
225 fi
226
227
228 #------------------------------------------------------------------------------#
229 echo_header "check that --android-home overrides ANDROID_HOME"
230
231 REPOROOT=`create_test_dir`
232 FAKE_ANDROID_HOME=`create_test_dir`
233 create_fake_android_home $FAKE_ANDROID_HOME
234 KEYSTORE=$REPOROOT/keystore.jks
235 cd $REPOROOT
236 $fdroid init --keystore $KEYSTORE --android-home $FAKE_ANDROID_HOME
237 set +e
238 grep $FAKE_ANDROID_HOME $REPOROOT/config.py
239 if [ $? -ne 0 ]; then
240     echo "the value set in --android-home '$FAKE_ANDROID_HOME' should override ANDROID_HOME '$ANDROID_HOME'"
241     exit 1
242 fi
243 set -e
244
245
246 #------------------------------------------------------------------------------#
247 # In this case, ANDROID_HOME is set to a fake, non-working version that will
248 # be detected by fdroid as an Android SDK install.  It should use the path set
249 # by --android-home over the one in ANDROID_HOME, therefore if it uses the one
250 # in ANDROID_HOME, it won't work because it is a fake one.  Only
251 # --android-home provides a working one.
252 echo_header "setup a new repo from scratch with keystore and android-home set on cmd line"
253
254 REPOROOT=`create_test_dir`
255 KEYSTORE=$REPOROOT/keystore.jks
256 FAKE_ANDROID_HOME=`create_test_dir`
257 create_fake_android_home $FAKE_ANDROID_HOME
258 STORED_ANDROID_HOME=$ANDROID_HOME
259 unset ANDROID_HOME
260 echo "ANDROID_HOME: $ANDROID_HOME"
261 cd $REPOROOT
262 $fdroid init --keystore $KEYSTORE --android-home $STORED_ANDROID_HOME --no-prompt
263 test -e $KEYSTORE
264 copy_apks_into_repo $REPOROOT
265 $fdroid update --create-metadata
266 grep -F '<application id=' repo/index.xml > /dev/null
267 test -e repo/index.xml
268 test -e repo/index.jar
269 export ANDROID_HOME=$STORED_ANDROID_HOME
270
271
272 #------------------------------------------------------------------------------#
273 echo_header "setup new repo from scratch using ANDROID_HOME, putting APKs in repo first"
274
275 REPOROOT=`create_test_dir`
276 cd $REPOROOT
277 mkdir repo
278 copy_apks_into_repo $REPOROOT
279 $fdroid init
280 $fdroid update --create-metadata
281 grep -F '<application id=' repo/index.xml > /dev/null
282
283
284 #------------------------------------------------------------------------------#
285 echo_header "setup a new repo from scratch and generate a keystore"
286
287 REPOROOT=`create_test_dir`
288 KEYSTORE=$REPOROOT/keystore.jks
289 cd $REPOROOT
290 $fdroid init --keystore $KEYSTORE
291 test -e $KEYSTORE
292 copy_apks_into_repo $REPOROOT
293 $fdroid update --create-metadata
294 test -e repo/index.xml
295 test -e repo/index.jar
296 grep -F '<application id=' repo/index.xml > /dev/null
297
298
299 #------------------------------------------------------------------------------#
300 echo_header "setup a new repo manually and generate a keystore"
301
302 REPOROOT=`create_test_dir`
303 KEYSTORE=$REPOROOT/keystore.jks
304 cd $REPOROOT
305 touch config.py
306 cp $WORKSPACE/examples/fdroid-icon.png $REPOROOT/
307 ! test -e $KEYSTORE
308 set +e
309 $fdroid update
310 if [ $? -eq 0 ]; then
311     echo "This should have failed because this repo has no keystore!"
312     exit 1
313 else
314     echo "`fdroid update` prompted to add keystore"
315 fi
316 set -e
317 $fdroid update --create-key
318 test -e $KEYSTORE
319 copy_apks_into_repo $REPOROOT
320 $fdroid update --create-metadata
321 test -e repo/index.xml
322 test -e repo/index.jar
323 grep -F '<application id=' repo/index.xml > /dev/null
324
325
326 #------------------------------------------------------------------------------#
327 echo_header "setup a new repo from scratch, generate a keystore, then add APK and update"
328
329 REPOROOT=`create_test_dir`
330 KEYSTORE=$REPOROOT/keystore.jks
331 cd $REPOROOT
332 $fdroid init --keystore $KEYSTORE
333 test -e $KEYSTORE
334 copy_apks_into_repo $REPOROOT
335 $fdroid update --create-metadata
336 test -e repo/index.xml
337 test -e repo/index.jar
338 grep -F '<application id=' repo/index.xml > /dev/null
339 cp $WORKSPACE/tests/urzip.apk $REPOROOT/
340 $fdroid update --create-metadata
341 test -e repo/index.xml
342 test -e repo/index.jar
343 grep -F '<application id=' repo/index.xml > /dev/null
344
345
346 #------------------------------------------------------------------------------#
347 echo_header "setup a new repo from scratch with a HSM/smartcard"
348
349 REPOROOT=`create_test_dir`
350 cd $REPOROOT
351 $fdroid init --keystore NONE
352 test -e opensc-fdroid.cfg
353 test ! -e NONE
354
355
356 #------------------------------------------------------------------------------#
357 echo_header "setup a new repo with no keystore, add APK, and update"
358
359 REPOROOT=`create_test_dir`
360 KEYSTORE=$REPOROOT/keystore.jks
361 cd $REPOROOT
362 touch config.py
363 touch fdroid-icon.png
364 mkdir repo/
365 cp $WORKSPACE/tests/urzip.apk $REPOROOT/
366 set +e
367 $fdroid update --create-metadata
368 if [ $? -eq 0 ]; then
369     echo "This should have failed because this repo has no keystore!"
370     exit 1
371 else
372     echo "`fdroid update` prompted to add keystore"
373 fi
374 set -e
375
376 # now set up fake, non-working keystore setup
377 touch $KEYSTORE
378 echo "keystore = \"$KEYSTORE\"" >> config.py
379 echo 'repo_keyalias = "foo"' >> config.py
380 echo 'keystorepass = "foo"' >> config.py
381 echo 'keypass = "foo"' >> config.py
382 set +e
383 $fdroid update --create-metadata
384 if [ $? -eq 0 ]; then
385     echo "This should have failed because this repo has a bad/fake keystore!"
386     exit 1
387 else
388     echo "`fdroid update` prompted to add keystore"
389 fi
390 set -e
391
392
393 #------------------------------------------------------------------------------#
394 echo_header "setup a new repo with keystore with APK, update, then without key"
395
396 REPOROOT=`create_test_dir`
397 KEYSTORE=$REPOROOT/keystore.jks
398 cd $REPOROOT
399 $fdroid init --keystore $KEYSTORE
400 test -e $KEYSTORE
401 cp $WORKSPACE/tests/urzip.apk $REPOROOT/repo/
402 $fdroid update --create-metadata
403 test -e repo/index.xml
404 test -e repo/index.jar
405 grep -F '<application id=' repo/index.xml > /dev/null
406
407 # now set fake repo_keyalias
408 sed -i 's,^ *repo_keyalias.*,repo_keyalias = "fake",' $REPOROOT/config.py
409 set +e
410 $fdroid update
411 if [ $? -eq 0 ]; then
412     echo "This should have failed because this repo has a bad repo_keyalias!"
413     exit 1
414 else
415     echo "`fdroid update` prompted to add keystore"
416 fi
417 set -e
418
419 # try creating a new keystore, but fail because the old one is there
420 test -e $KEYSTORE
421 set +e
422 $fdroid update --create-key
423 if [ $? -eq 0 ]; then
424     echo "This should have failed because a keystore is already there!"
425     exit 1
426 else
427     echo "`fdroid update` complained about existing keystore"
428 fi
429 set -e
430
431 # now actually create the key with the existing settings
432 rm -f $KEYSTORE
433 ! test -e $KEYSTORE
434 $fdroid update --create-key
435 test -e $KEYSTORE
436
437
438 #------------------------------------------------------------------------------#
439
440 # remove this to prevent git conflicts and complaining
441 rm -rf $WORKSPACE/fdroidserver.egg-info/
442
443 echo SUCCESS